Attribute VB_Name = "modPUGbasedIDsConverter"
Option Explicit

Function chemIdsBatchConverter(origin As Range, Optional originType = "auto") As String()
    On Error GoTo exitPoint
    
    Dim browser As Object
    Dim response() As String
    Dim infos() As String
    Dim responseLines() As String
    Dim responseText As String
    Dim postText As String
    Dim startTime As Date
    Dim startTimeG As Date
    Dim queryUidName As String
    Dim i As Long
    Dim j As Long
    
    startTimeG = Now()
    If origin.Rows.Count = 1 Or origin.Columns.Count = 1 Then
        'identify origin type
        Select Case originType
            Case Mid("smiles", 1, Len(originType))
                originType = "smiles"
            Case Mid("inchi", 1, Len(originType))
                originType = "inchi"
            Case Mid("cids", 1, Len(originType))
                originType = "cid"
            Case Mid("names", 1, Len(originType))
                originType = "synonym"
            Case Mid("synonyms", 1, Len(originType))
                originType = "synonym"
            Case Else 'auto
                originType = "synonym"
                If IsNumeric(origin.Cells(1, 1).Value) Then originType = "cid"
        End Select
        
        Set browser = CreateObject("MSXML2.XMLHTTP.6.0")
        
        If originType <> "cid" Then
            queryUidName = originType
            If queryUidName = "synonym" Or queryUidName = "inchi" Then queryUidName = queryUidName & "s"
            
            postText = ""
            For i = 1 To origin.Rows.Count
                For j = 1 To origin.Columns.Count
                    postText = postText & "<PCT-QueryUids_" & queryUidName & "_E>" & _
                            origin.Cells(i, j).Value & _
                            "</PCT-QueryUids_" & queryUidName & "_E>"
                Next
            Next
            
            postText = "<PCT-Data><PCT-Data_input><PCT-InputData><PCT-InputData_query><PCT-Query><PCT-Query_type><PCT-QueryType><PCT-QueryType_id-exchange>" & _
                    " <PCT-QueryIDExchange><PCT-QueryIDExchange_input><PCT-QueryUids><PCT-QueryUids_" & queryUidName & ">" & postText
            
            postText = postText & "</PCT-QueryUids_" & queryUidName & ">" & _
            " </PCT-QueryUids></PCT-QueryIDExchange_input><PCT-QueryIDExchange_operation-type value='same'/><PCT-QueryIDExchange_output-type value='cid'/>" & _
            " <PCT-QueryIDExchange_output-method value='file-pair'/><PCT-QueryIDExchange_compression value='none'/></PCT-QueryIDExchange></PCT-QueryType_id-exchange>" & _
            " </PCT-QueryType></PCT-Query_type></PCT-Query></PCT-InputData_query></PCT-InputData></PCT-Data_input></PCT-Data>"
        
            browser.Open "POST", _
                    "https://pubchem.ncbi.nlm.nih.gov/pug/pug.cgi", False
            browser.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
            browser.Send postText
            responseText = browser.responseText
                    
            Do While InStr(responseText, "success") = 0
                startTime = Now()
                Do While Now() < startTime + TimeSerial(0, 0, 2)
                    DoEvents
                Loop
                
                postText = Mid(responseText, InStr(responseText, "<PCT-Waiting_reqid>") + 19, _
                        InStr(responseText, "</PCT-Waiting_reqid>") - InStr(responseText, "<PCT-Waiting_reqid>") - 19)
                
                postText = "<PCT-Data><PCT-Data_input><PCT-InputData><PCT-InputData_request><PCT-Request><PCT-Request_reqid>" & postText
                postText = postText & "</PCT-Request_reqid><PCT-Request_type value='status'/></PCT-Request></PCT-InputData_request></PCT-InputData></PCT-Data_input></PCT-Data>"
                
                browser.Open "POST", _
                        "https://pubchem.ncbi.nlm.nih.gov/pug/pug.cgi", False
                browser.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
                browser.Send postText
                responseText = browser.responseText
                    
            Loop
            
            postText = Mid(responseText, InStr(responseText, "<PCT-Download-URL_url>") + 22, _
                        InStr(responseText, "</PCT-Download-URL_url>") - InStr(responseText, "<PCT-Download-URL_url>") - 22)
            
            browser.Open "GET", _
                    postText, False
            browser.Send
            responseText = browser.responseText
            
      
            responseLines = Split(responseText, vbLf)
            
            postText = ""
            For i = 0 To UBound(responseLines) - 1
                postText = postText & "," & Split(responseLines(i), vbTab)(1)
            Next
            postText = Mid(postText, 2, Len(postText))
            
        Else
            'generate post data
            postText = ""
            For i = 1 To origin.Rows.Count
                For j = 1 To origin.Columns.Count
                    postText = postText & "," & _
                            Application.WorksheetFunction.EncodeURL(origin.Cells(i, j).Value)
                Next
            Next
            postText = Mid(postText, 2, Len(postText))
        End If
        
        
        browser.Open "POST", _
                "https://pubchem.ncbi.nlm.nih.gov/rest/pug/compound/cid/property/IUPACName,InChI,CanonicalSMILES/CSV", False
        browser.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
        browser.Send "cid=" & postText
        responseText = browser.responseText
        Set browser = Nothing
        
        responseLines = Split(responseText, vbLf)
        If origin.Rows.Count = 1 Then
            ReDim response(0 To 3, 0 To origin.Columns.Count - 1)
            
            For i = 0 To origin.Columns.Count - 1
                infos = Split(responseLines(i + 1), ",""")
                response(0, i) = infos(0)
                response(1, i) = Mid(infos(1), 1, Len(infos(1)) - 1)
                response(2, i) = Mid(infos(2), 1, Len(infos(2)) - 1)
                response(3, i) = Mid(infos(3), 1, Len(infos(3)) - 1)
            Next
        Else
            ReDim response(0 To origin.Rows.Count - 1, 0 To 3)
            
            For i = 0 To origin.Rows.Count - 1
                infos = Split(responseLines(i + 1), ",""")
                response(i, 0) = infos(0)
                response(i, 1) = Mid(infos(1), 1, Len(infos(1)) - 1)
                response(i, 2) = Mid(infos(2), 1, Len(infos(2)) - 1)
                response(i, 3) = Mid(infos(3), 1, Len(infos(3)) - 1)
            Next
        
        End If
        
        Do While Now() < startTimeG + TimeSerial(0, 0, 1)
        Loop
        
        chemIdsBatchConverter = response
        
        Exit Function
    End If
exitPoint:
    chemIdsBatchConverter = Array(1 / 0)
End Function


Function chemCID2IDs(origin As Range) As String()
    chemCID2IDs = chemIdsBatchConverter(origin, "cid")
End Function
